#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);

    cin.tie(0);

    int n , h ;

    cin >> h >> n;

    int a[n], kraj[n];


    for(int i = 0 ; i < n ;i++)
    {
        kraj[i] = 1;
    }

    int brReda = 1;




    while(h>0 ){

        for(int i =0 ; i < n ;i++)
        {
            cin >> a[i];

        }
    int zbir = 0;

    int p1 = -10000;

    for(int j = 0 ; j < n ;j++){


            if(a[j] == 0 && j== 0)
            {
                zbir += kraj[j];


                 kraj[j] = 0;
            }
            else if (a[j] == 0 && j == n-1)
            {
                if(zbir)
                {
                    kraj[p1] += zbir + kraj[n-1];
                }
               else
                 kraj[n-2] += kraj[n-1];

                 kraj[j] = 0;
                 zbir = 0;

            }

            else if(a[j] == 0 )
            {
                zbir = zbir + kraj[j];

                 kraj[j] = 0; // racunamo kada su 0
            }

            else if(a[j] == 1 )
            {

                // racnamo kada je 1
                if(p1 != -10000 && zbir)
                {
                    if(brReda % 2 == 0)
                    {

                        kraj[p1] += zbir/2;

                        kraj[j] += zbir/2 + zbir%2 ;


                    }
                    else if(brReda%2)
                    {
                        kraj[p1] +=zbir/2 + zbir%2;

                        kraj[j] += zbir / 2;

                    }
                    zbir = 0;
                }

                else if(zbir)
                {

                   kraj[j] += zbir;

                    zbir = 0;
                }

               p1 = j ;


            }



    }


        brReda++;
        h--;
    }


    if(n == 1)
        {
            cout << a[0];

        }

    else if (n  > 1 )
        {

            for(int i = 0 ; i < n ; i++)
                cout<< kraj[i] << " ";

        }

    return 0;
}